<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="职位标题" prop="title">
        <el-input v-model="formData.title" placeholder="请输入职位标题" />
      </el-form-item>
      <el-form-item label="职位描述" prop="description">
        <Editor v-model="formData.description" height="150px" />
      </el-form-item>
      <el-form-item label="职位要求" prop="requirement">
        <el-input v-model="formData.requirement" placeholder="请输入职位要求" />
      </el-form-item>
      <el-form-item label="城市ID" prop="cityId">
        <el-input v-model="formData.cityId" placeholder="请输入城市ID" />
      </el-form-item>
      <el-form-item label="职位类别ID" prop="jobCategoryId">
        <el-input v-model="formData.jobCategoryId" placeholder="请输入职位类别ID" />
      </el-form-item>
      <el-form-item label="发布时间" prop="publishTime">
        <el-date-picker
          v-model="formData.publishTime"
          type="date"
          value-format="x"
          placeholder="选择发布时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { JobPostApi, JobPostVO } from '@/api/portal/jobpost'

/** 职位 表单 */
defineOptions({ name: 'JobPostForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  title: undefined,
  description: undefined,
  requirement: undefined,
  cityId: undefined,
  jobCategoryId: undefined,
  publishTime: undefined
})
const formRules = reactive({
  title: [{ required: true, message: '职位标题不能为空', trigger: 'blur' }],
  cityId: [{ required: true, message: '城市ID不能为空', trigger: 'blur' }],
  jobCategoryId: [{ required: true, message: '职位类别ID不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await JobPostApi.getJobPost(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as JobPostVO
    if (formType.value === 'create') {
      await JobPostApi.createJobPost(data)
      message.success(t('common.createSuccess'))
    } else {
      await JobPostApi.updateJobPost(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    title: undefined,
    description: undefined,
    requirement: undefined,
    cityId: undefined,
    jobCategoryId: undefined,
    publishTime: undefined
  }
  formRef.value?.resetFields()
}
</script>